#define NUM_TEXTS 40
#define TEXT_X_SIZE 85
#define TEXT_Y_SIZE 8
#define CENTER1_X 120
#define CENTER1_Y (-40)
#define CENTER2_X (-220)
#define CENTER2_Y 140
#define FPS_MIN 10
#define FPS_MAX 100
#define VOL_MIN 0
#define VOL_MAX 127

#define GM_MENU_MAIN 0
#define GM_MENU_OPTS 1
#include "locale.h"
#include "gamemenu.h"
#include "images.h"
#include "log.h"
#include "math.h"
#include "sg.h"
#include "misc.h"
#include "stdlib.h"
#include "sound.h"
#include <SDL/SDL_mixer.h>
#include <bzlib.h>
extern int what_to_do;
char gamemenu_usemouse;
SDL_Surface *screencopy1,*screencopy2,*text1,*text2;
struct FLYING_TEXT {float x,y;Uint32 col;};
struct FLYING_TEXT flying_texts[NUM_TEXTS];
int gamemenu_testsg(void)
{
BZFILE *f;
SAVE_REC r;
SGname[SGOFFSET]='0'+what_to_do/10;SGname[SGOFFSET+1]='0'+what_to_do%10;
if ((f=BZ2_bzopen(SGname,"r"))==NULL)return -1;
if (BZ2_bzread(f,&r,sizeof(SAVE_REC))<(int)sizeof(SAVE_REC)){BZ2_bzclose(f);return(-1);}else{BZ2_bzclose(f);return(0);};
}
void gamemenu_outsmth(int x,int y,char *c)
{
font->OutText(x-1,y-1,SDL_MapRGB(screen->format,25,25,25),c,screen);
font->OutText(x-1,y-1,SDL_MapRGB(screen->format,25,25,25),c,screen);
font->OutText(x-1,y,SDL_MapRGB(screen->format,25,25,25),c,screen);
font->OutText(x-1,y+1,SDL_MapRGB(screen->format,25,25,25),c,screen);
font->OutText(x+1,y-1,SDL_MapRGB(screen->format,25,25,25),c,screen);
font->OutText(x+1,y,SDL_MapRGB(screen->format,25,25,25),c,screen);
font->OutText(x+1,y+1,SDL_MapRGB(screen->format,25,25,25),c,screen);
font->OutText(x,y-1,SDL_MapRGB(screen->format,25,25,25),c,screen);
font->OutText(x,y+1,SDL_MapRGB(screen->format,25,25,25),c,screen);
font->OutText(x,y,SDL_MapRGB(screen->format,255,255,255),c,screen);
}
void gamemenu_showsg(void)
{
int i;
BZFILE *f;
struct SAVE_REC rec;
SDL_BlitSurface(screencopy1,NULL,screen,NULL);
for (i=0;i<NUM_OF_SG;i++){
SGname[SGOFFSET]='0'+i/10;SGname[SGOFFSET+1]='0'+i%10;
if ((f=BZ2_bzopen(SGname,"r"))!=NULL){
if (BZ2_bzread(f,&rec,sizeof(rec))==sizeof(rec)){
BZ2_bzclose(f);
gamemenu_outsmth(120,100+20*i,ctime(&(rec.savetime)));
gamemenu_outsmth(320,100+20*i,&(EPISODES_NAMES[rec.episode_no][0]));
} else {BZ2_bzclose(f);gamemenu_outsmth(120,100+20*i,LOCALE_UNUSED_SLOT);};
}else{gamemenu_outsmth(120,100+20*i,LOCALE_UNUSED_SLOT);};
};
gamemenu_outsmth(120,400,LOCALE_MENU_LOADCANCEL);
SDL_BlitSurface(screen,NULL,screencopy2,NULL);
}
int gamemenu_get_choice(int num_choices,char type)
{
SDL_Event event;
float alpha,scale,fl_temp,scale1,scale2;
int c_ch=0,c_chosen=0,i1,v=0;
SDL_Rect r1;
Uint32 time;
misc_getkeyboard();
while (c_chosen==0){
time=SDL_GetTicks();
while (SDL_PollEvent(&event)){
switch (event.type){
case SDL_KEYUP:switch (event.key.keysym.sym){
case SDLK_UP:c_ch=(c_ch+num_choices-1)%num_choices;break;
case SDLK_DOWN:c_ch=(c_ch+1)%num_choices;break;
case SDLK_SPACE:case SDLK_RETURN:case SDLK_KP_ENTER:if ((type!=GM_MENU_OPTS)||(c_ch==num_choices-1))c_chosen=1;break;
case SDLK_ESCAPE: if (c_ch==num_choices-1){c_chosen=1;}else{c_ch=num_choices-1;};break;
case SDLK_LEFT:v++;break;
case SDLK_RIGHT:v--;break;
default:break;
};break;
case SDL_KEYDOWN:switch (event.key.keysym.sym){
case SDLK_LEFT:v--;break;
case SDLK_RIGHT:v++;break;
default:break;
};break;
case SDL_QUIT:SDL_Quit();break;
case SDL_MOUSEMOTION:if (gamemenu_usemouse==1){
if ((event.motion.y>=95)&&(event.motion.y<95+20*num_choices)){c_ch=(event.motion.y-95)/20;};};break;
case SDL_MOUSEBUTTONDOWN:if (gamemenu_usemouse==1){c_chosen=1;};break;
};
};
if ((type==GM_MENU_OPTS)&&(c_ch!=num_choices-1)&&(v!=0))switch(c_ch){
  case 0:if ((fps+v>=FPS_MIN)&&(fps+v<=FPS_MAX))fps+=v;break;
  case 1:if ((SND_MUS_volume+v>=VOL_MIN)&&(SND_MUS_volume+v<=VOL_MAX)){SND_MUS_volume+=v;SND_SetMVolume();};break;
  case 2:if ((SND_WAV_volume+v>=VOL_MIN)&&(SND_WAV_volume+v<=VOL_MAX)){SND_WAV_volume+=v;SND_SetWVolume();};break;
  };
alpha=(3.14*(rand()%100)-50)/9000;scale=1.01+(rand()%100)/1000;
scale1=1.01+(rand()%100)/1000;scale2=1.01+(rand()%100)/1000;
for (i1=0;i1<NUM_TEXTS;i1++){

flying_texts[i1].x*=scale;flying_texts[i1].y*=scale;
fl_temp=flying_texts[i1].x;
flying_texts[i1].x=fl_temp*cos(alpha)-flying_texts[i1].y*sin(alpha);flying_texts[i1].y=fl_temp*sin(alpha)+flying_texts[i1].y*cos(alpha);

flying_texts[i1].x-=CENTER1_X;flying_texts[i1].y-=CENTER1_Y;
flying_texts[i1].x*=scale1;flying_texts[i1].y*=scale1;fl_temp=flying_texts[i1].x;
flying_texts[i1].x=fl_temp*cos(alpha)-flying_texts[i1].y*sin(alpha);flying_texts[i1].y=fl_temp*sin(alpha)+flying_texts[i1].y*cos(alpha);
flying_texts[i1].x+=CENTER1_X;flying_texts[i1].y+=CENTER1_Y;

flying_texts[i1].x-=CENTER2_X;flying_texts[i1].y-=CENTER2_Y;
flying_texts[i1].x*=scale2;flying_texts[i1].y*=scale1;fl_temp=flying_texts[i1].x;
flying_texts[i1].x=fl_temp*cos(alpha)-flying_texts[i1].y*sin(alpha);flying_texts[i1].y=fl_temp*sin(alpha)+flying_texts[i1].y*cos(alpha);
flying_texts[i1].x+=CENTER2_X;flying_texts[i1].y+=CENTER2_Y;

while (flying_texts[i1].x<-320.0){flying_texts[i1].x+=320.0;};while (flying_texts[i1].y<-240.0){flying_texts[i1].y+=240.0;};
while (flying_texts[i1].x>=320.0){flying_texts[i1].x-=320.0;};while (flying_texts[i1].y>=240.0){flying_texts[i1].y-=240.0;};
};
SDL_FillRect(screen,NULL,C_BLACK(screen));
r1.w=TEXT_X_SIZE;r1.h=TEXT_Y_SIZE;
for(i1=0;i1<NUM_TEXTS;i1++){
r1.x=(Sint16)flying_texts[i1].x+320;r1.y=(Sint16)flying_texts[i1].y+240;
SDL_FillRect(text2,NULL,flying_texts[i1].col);
SDL_BlitSurface(text1,NULL,text2,NULL);
SDL_BlitSurface(text2,NULL,screen,&r1);
};
SDL_BlitSurface(screencopy2,NULL,screen,NULL);
ASSIGNRECT(r1,100,100+c_ch*20,8,8);
SDL_BlitSurface(images[_IMG_arrow_r],NULL,screen,&r1);
if (type==GM_MENU_OPTS){
char fps_str[4]={(fps>=100)?(fps/100+'0'):(' '),(fps/10)%10+'0',fps%10+'0',0};
ASSIGNRECT(r1,250-1+200*(fps-FPS_MIN)/(FPS_MAX-FPS_MIN),100,3,10);
    SDL_FillRect(screen,&r1,SDL_MapRGB(screen->format,221,200,61));
ASSIGNRECT(r1,250-1+200*(SND_MUS_volume-VOL_MIN)/(VOL_MAX-VOL_MIN),120,3,10);
    SDL_FillRect(screen,&r1,SDL_MapRGB(screen->format,92,227,24));
ASSIGNRECT(r1,250-1+200*(SND_WAV_volume-VOL_MIN)/(VOL_MAX-VOL_MIN),140,3,10);
    SDL_FillRect(screen,&r1,SDL_MapRGB(screen->format,52,171,175));
font->OutText(470,100,C_WHITE(screen),(fps!=FPS_MAX)?(&(fps_str[0])):((char *)"No limit"),screen);
};
SDL_Flip(screen);
while (SDL_GetTicks()<time+1000/fps);
};
return (c_ch);
}
int gamemenu(char mouse_is_showing)
{
int i1,i2;
char resault=0;
Uint32 scr_black=C_BLACK(screen);
SDL_Rect r1={0,0,1,1};
fprintf(LOG,"Gamemenu.\n");
gamemenu_usemouse=mouse_is_showing;
screencopy1=SDL_CreateRGBSurface(SDL_RLEACCEL|SDL_HWSURFACE,640,480,32,SURFACE_COLOURS);
screencopy2=SDL_CreateRGBSurface(SDL_RLEACCEL|SDL_HWSURFACE,640,480,32,SURFACE_COLOURS);
text1=SDL_CreateRGBSurface(SDL_RLEACCEL|SDL_HWSURFACE,TEXT_X_SIZE,TEXT_Y_SIZE,24,SURFACE_COLOURS);
text2=SDL_CreateRGBSurface(SDL_RLEACCEL|SDL_HWSURFACE,TEXT_X_SIZE,TEXT_Y_SIZE,24,SURFACE_COLOURS);
SDL_SetColorKey(text2,SDL_SRCCOLORKEY|SDL_RLEACCEL,C_BLACK(text2));
SDL_SetColorKey(text1,SDL_RLEACCEL,C_BLACK(text2));
SDL_FillRect(text1,NULL,C_BLACK(text1));
font->OutText(0,0,C_WHITE(text1),"CRAZY HENDEHOH",text1);
SDL_SetColorKey(text1,SDL_SRCCOLORKEY,C_WHITE(text1));
SDL_LockSurface(screen);
for (i1=0;i1<480;i1++)for(i2=0;i2<320;i2++){
  Uint8 *p=(Uint8*)screen->pixels+i1*screen->pitch+(i2*2+i1%2)*screen->format->BytesPerPixel;*(Uint32*)p=scr_black;};
SDL_UnlockSurface(screen);
SDL_BlitSurface(images[_IMG_menu_fon],NULL,screen,NULL);SDL_BlitSurface(screen,NULL,screencopy1,NULL);
for (i1=0;i1<NUM_TEXTS;i1++){
  flying_texts[i1].x=(rand()%640)-320;flying_texts[i1].y=(rand()%480)-240;
  flying_texts[i1].col=SDL_MapRGB(text1->format,rand()%50+200,rand()%50+200,rand()%50+200);};
gamemenu_outsmth(120,100,LOCALE_MENU_SETMUSIC);
gamemenu_outsmth(120,120,LOCALE_MENU_CONTINUE);
gamemenu_outsmth(120,140,LOCALE_MENU_NEWGAME);
gamemenu_outsmth(120,160,LOCALE_MENU_SAVEGAME);
gamemenu_outsmth(120,180,LOCALE_MENU_LOADGAME);
gamemenu_outsmth(120,200,LOCALE_MENU_HELP);
gamemenu_outsmth(120,220,LOCALE_MENU_OPTIONS);
gamemenu_outsmth(120,240,LOCALE_MENU_EXIT);
SDL_BlitSurface(screen,NULL,screencopy2,NULL);SDL_SetColorKey(screencopy2,SDL_SRCCOLORKEY,C_BLACK(screencopy2));
switch (gamemenu_get_choice(8,GM_MENU_MAIN))
{
case 0:if ((num_extramusics!=0)&&(SND_enabled)){int i;
  SDL_BlitSurface(screencopy1,NULL,screen,NULL);for (i=0;i<num_extramusics;i++)gamemenu_outsmth(120,100+20*i,SND_extramusic[i].name);
  SDL_BlitSurface(screen,NULL,screencopy2,NULL);SND_SetExtraMusic(gamemenu_get_choice(num_extramusics,GM_MENU_MAIN));};break;
case 1:resault=GAMEMENU_JUSTPLAY;break;
case 2:resault=GAMEMENU_QUIT;what_to_do=WHAT_FIRSTLEVEL;break;
case 3:SDL_BlitSurface(screencopy1,NULL,screen,NULL);gamemenu_showsg();what_to_do=gamemenu_get_choice(NUM_OF_SG+1,GM_MENU_MAIN);
    if (what_to_do==NUM_OF_SG){resault=GAMEMENU_JUSTPLAY;}else{resault=GAMEMENU_SAVEFIRST+what_to_do;};break;
case 4:SDL_BlitSurface(screencopy1,NULL,screen,NULL);gamemenu_showsg();what_to_do=gamemenu_get_choice(NUM_OF_SG+1,GM_MENU_MAIN);
    if (what_to_do==NUM_OF_SG){resault=GAMEMENU_JUSTPLAY;}else{if (gamemenu_testsg()==0){resault=GAMEMENU_QUIT;};};break;
case 5:resault=GAMEMENU_HELP;break;
case 6:resault=GAMEMENU_JUSTPLAY;SDL_BlitSurface(screencopy1,NULL,screen,NULL);
  gamemenu_outsmth(120,100,LOCALE_MENU_FPS);gamemenu_outsmth(120,120,LOCALE_MENU_MUS_VOL);
  gamemenu_outsmth(120,140,LOCALE_MENU_SND_VOL);gamemenu_outsmth(120,160,LOCALE_MENU_OPTSQUIT);
  ASSIGNRECT(r1,249,103,202,4);SDL_FillRect(screen,&r1,SDL_MapRGB(screen->format,92,227,24));
  ASSIGNRECT(r1,249,123,202,4);SDL_FillRect(screen,&r1,SDL_MapRGB(screen->format,52,171,175));
  ASSIGNRECT(r1,249,143,202,4);SDL_FillRect(screen,&r1,SDL_MapRGB(screen->format,221,200,61));
  SDL_BlitSurface(screen,NULL,screencopy2,NULL);gamemenu_get_choice(4,GM_MENU_OPTS);break;
case 7:resault=GAMEMENU_QUIT;what_to_do=WHAT_QUIT;break;
};
SDL_FreeSurface(screencopy1);SDL_FreeSurface(screencopy2);
SDL_FreeSurface(text1);SDL_FreeSurface(text2);
return resault;
}
