#include "hif_main.h"
#include "misc.h"
#include "images.h"
void hif_help(void)
{
static char help_text_ru[]=" .\n\n"
"  -  , , (  ),()\n"
"CTRL -   , ALT -    ,\n"
"1-9 -   ,   -    ,\n"
"F12 -  FPS, m -        ,\n"
" - ,  SHIFT -    ,  -   \n"
" -   (  ,   ,   )\n"
"p -  ;    , 1-6 - .\n"
"Insert,Delete,Home,End -   .      (    ),\n"
"  ()    ,    , \n"
"      ";
static char help_text_en[]="Small documentation.\n\n"
"Moving hedgehog - by left, right, up (jump) and down (get down) buttons,\n"
"CTRL - open door, ALT - press button or pull something,\n"
"1-9 and square brackets - choose weapon\n"
"F12 - show FPS, m - explode mines in the half screen diagonal radius\n"
"SPACE - shoot, right SHIFT - push bee, left SHIFT - pull bee,\n"
"EQUAL - shoot dot (dot makes flowers explode, droids fall, other enemies show health)\n"
"p - panel, when panel is on screen, 1-6 - things on panel\n"
"Insert,Delete,Home,End - change hedgehog's state. First three states are simular (but the third\n"
"does not allow to shoot), and the fourth doues not allow to take things, shoot, open doors, but\n"
"increases speed and bumping."
;
char *help_texts[LOCALE_MAX+1]={help_text_ru,help_text_en};
SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,200,0,0));
font->OutText(50,50,C_WHITE(screen),help_texts[locale_type],screen);
SDL_Flip(screen);
misc_waitforkey();
misc_getkeyboard();
}
