#include "hif_levels.h"
#include "hif_main.h"
#include <string.h>
#include "images.h"
#include "log.h"
#define IN_RECT(r) ((hif_player_info.x>=(r).x)&&(hif_player_info.y>=(r).y)&&(hif_player_info.x<=(r).x+(r).w)&&(hif_player_info.y<=(r).y+(r).h))
#define HIF_SetPanel(t) {hif_player_info.apanel_opts[t]=1;if ((hif_player_info.apanel_state==HIF_PANEL_HIDING)||\
          (hif_player_info.apanel_state==HIF_PANEL_NONE)){hif_player_info.apanel_state=HIF_PANEL_SHOWING;\
              hif_player_info.apanel_phase=HIF_PANEL_NUMPHASES;hif_player_info.apanel_pos=1;};}
void hif_level1_handler(char a,int p,BZFILE *f,int x0,int y0)
{
static char flags[7];
static char *hints[7][2]={
{"     .      -   .",
                                                          "You can stay inthe river not too long. Get to the floor to open the block in the right."},
{"   ,  .","There is an air hole. Jump into it a few times to breathe."},
{"     ALT.","There is a button. Press it using ALT button."},
{" .","Get down to look what is there."},
{"  .","Get up by the ladder."},
{" END.   ,       (LCTRL).",
                                  "Press END. Then kill the ball. Get the key and get down to the red door. Open it by LCTRL."},
{
" END  .   - Insert, Delete, Home.  End      .",
                        "Press END to increase speed. Press Insert, Delete or Home to change states. In End state you cannot open doors."}};
static SDL_Rect rects[6]={{130,360,160,380},{130,620,160,680},{360,1520,390,1560},{968,410,1000,427},{1010,1520,1020,1547},
                {1000,0,1030,347}};
switch (a){
case HIF_LEVHAND_SAVE:BZ2_bzwrite(f,flags,7);break;
case HIF_LEVHAND_LOAD:BZ2_bzread(f,flags,7);break;
case HIF_LEVHAND_PROCIDLE:if ((flags[0]==1)&&(hif_ticks%20==0))if (hif_level_info.blocks[0].y2-hif_level_info.blocks[0].y1>160)
    hif_level_info.blocks[0].y2--;break;
case HIF_LEVHAND_INIT:memset(flags,0,7);break;
case HIF_LEVHAND_BUTTON:flags[0]=1;break;
case HIF_LEVHAND_PREBUTTON:hif_player_info.phase=10;break;
};
if (IN_RECT(rects[0])&&(flags[1]==0)){flags[1]=1;HIF_AddHintSurface(hints[0][locale_type]);HIF_AddHintSurface(hints[6][locale_type]);};
if (IN_RECT(rects[1])&&(flags[2]==0)){flags[2]=1;HIF_AddHintSurface(hints[1][locale_type]);};
if (IN_RECT(rects[2])&&(flags[3]==0)){flags[3]=1;HIF_AddHintSurface(hints[2][locale_type]);};
if (IN_RECT(rects[3])&&(flags[4]==0)){flags[4]=1;HIF_AddHintSurface(hints[3][locale_type]);};
if (IN_RECT(rects[4])&&(flags[5]==0)){flags[5]=1;HIF_AddHintSurface(hints[4][locale_type]);};
if (IN_RECT(rects[5])&&(flags[6]==0)){flags[6]=1;HIF_AddHintSurface(hints[5][locale_type]);};
}
void hif_level2_handler(char a,int p,BZFILE *f,int x0,int y0)
{
char i;
switch (a){
case HIF_LEVHAND_PREBUTTON:if (p==19*32+2){hif_player_info.x=100;hif_player_info.y=120;hif_player_info.state=HIF_STATE_WALKING;}
                                  else{hif_player_info.phase=12;};break;
case HIF_LEVHAND_BUTTON:switch(p){
case 734:hif_level_info.delta_x0=120-120-hif_player_info.x;hif_player_info.x=120;
hif_level_info.delta_y0=120-120-hif_player_info.y;hif_player_info.y=120;for (i=0;i<6;i++)hif_player_info.apanel_opts[i]=1;break;//right-down
case 260:hif_level_info.delta_x0=40*hif_level_info.xsize-160-hif_player_info.x;hif_player_info.x=40*hif_level_info.xsize-120;
hif_level_info.delta_y0=40*hif_level_info.ysize-120-hif_player_info.y;hif_player_info.y=40*hif_level_info.ysize-80;break;//up
};break;
};
}
void hif_level3_handler(char a,int p,BZFILE *f,int x0,int y0)
{
static char is_freeing,i;
int i2=0;
switch(a){
case HIF_LEVHAND_INIT:is_freeing=0;break;
case HIF_LEVHAND_SAVE:BZ2_bzwrite(f,&is_freeing,1);break;
case HIF_LEVHAND_LOAD:BZ2_bzread(f,&is_freeing,1);break;
case HIF_LEVHAND_PROCIDLE:switch(is_freeing){
case 0:break;
case 1:for (i=0;i<hif_level_info.numrivers;i++)if (hif_level_info.rivers[i].ys>3)
        {hif_level_info.rivers[i].ys--;if (hif_ticks%2==0)hif_level_info.rivers[i].y++;i2=1;};if (i2==0)is_freeing=2;break;
case 2:for (i=0;i<hif_level_info.numrivers;i++)if (hif_level_info.rivers[i].xs>5)
  {i2=1;hif_level_info.rivers[i].x++;hif_level_info.rivers[i].xs--;};if (i2==0)is_freeing=3;break;
case 3:for (i=1;i<hif_level_info.numrivers;i++)if (hif_level_info.rivers[i].y>560){hif_level_info.rivers[i].y--;i2=1;}
  if (i2==0)is_freeing=4;break;
case 4:for (i=1;i<hif_level_info.numrivers;i++)if (hif_level_info.rivers[i].x<40*hif_level_info.xsize-45){hif_level_info.rivers[i].x++;i2=1;}
  if (i2==0)is_freeing=5;break;};break;
case HIF_LEVHAND_REFRIDLE:break;
case HIF_LEVHAND_PREBUTTON:hif_player_info.phase=40;break;
case HIF_LEVHAND_BUTTON:if (is_freeing==0)is_freeing=1;break;
};
}
void hif_level4_handler(char a,int p,BZFILE *f,int x0,int y0)
{
switch (a){
case HIF_LEVHAND_PREBUTTON:hif_player_info.phase=1;break;
case HIF_LEVHAND_BUTTON:switch (p){
case 161:case 162:case 163:case 164:case 165:hif_player_info.x=480;hif_player_info.y=120;break;
case 142:hif_player_info.x=140;hif_player_info.y=60;break;
};break;
};
}
void hif_level5_handler(char a,int p,BZFILE *f,int x0,int y0)
{
#define HANOYSIZE 3
static char hanoy[HANOYSIZE],cells[2];
static int winphase;
static const int places[3][2]={{250,20},{370,60},{530,20}};
char i,c=-1;
switch (a){
case HIF_LEVHAND_SAVE:BZ2_bzwrite(f,hanoy,HANOYSIZE);BZ2_bzwrite(f,cells,2);BZ2_bzwrite(f,&winphase,4);break;
case HIF_LEVHAND_LOAD:BZ2_bzread(f,hanoy,HANOYSIZE);BZ2_bzread(f,cells,2);BZ2_bzread(f,&winphase,4);break;
case HIF_LEVHAND_REFRIDLE:for (i=0;i<HANOYSIZE;i++){
  SDL_Rect r1={180+140*((int)hanoy[i])+(80-5*i)-x0,150+10*i-y0,10*(i+1),8},r3={places[cells[0]][0]-x0,250-y0,places[cells[0]][1],20},
                          r2={180+140*((int)hanoy[i])+(80-5*i)-x0,642-10*i-y0,10*(i+1),8},r4={places[cells[1]][0]-x0,530-y0,places[cells[1]][1],20};
  HIF_FillRect(screen,&r1,C_WHITE(screen));HIF_FillRect(screen,&r2,C_WHITE(screen));
  HIF_FillRect(screen,&r3,SDL_MapRGB(screen->format,255,0,0));HIF_FillRect(screen,&r4,SDL_MapRGB(screen->format,0,255,0));
  };break;
case HIF_LEVHAND_INIT:for (i=0;i<HANOYSIZE;i++)hanoy[i]=0;cells[0]=cells[1]=0;winphase=0;break;
case HIF_LEVHAND_PROCIDLE:
if (winphase!=0){
  hif_player_info.weapon=(winphase-1)/100+1;hif_player_info.weapons[hif_player_info.weapon]++;
  if ((winphase++)==400)hif_victory=1;hif_to_update_panel=1;};break;
case HIF_LEVHAND_PREBUTTON:hif_player_info.phase=1;break;
case HIF_LEVHAND_BUTTON:switch (p){
case 129:case 130:cells[0]=1;break;
case 126:cells[0]=0;break;
case 133:cells[0]=2;break;
case 266:cells[1]=0;break;
case 273:cells[1]=2;break;
case 269:case 270:cells[1]=1;break;
case 187:case 192:case 207:case 212:
  for (i=0;i<HANOYSIZE;i++)if (hanoy[i]==cells[0]){c=i;break;};if (c==-1)break;
    for (i=0;i<c;i++)if (hanoy[i]==cells[1]){c=-1;break;};if (c==-1)break;hanoy[c]=cells[1];
    c=1;for (i=0;i<HANOYSIZE;i++)if (hanoy[i]!=1){c=0;break;};if (c==1)winphase=1;
    c=1;for (i=0;i<HANOYSIZE;i++)if (hanoy[i]!=2){c=0;break;};if (c==1)winphase=1;break;
};break;
};
}
void hif_level6_handler(char a,int p,BZFILE *f,int x0,int y0)
{
static char door_state=0;
int i;
static char flags[6];
static SDL_Rect rects[6]={{40,1000,80,480},{1360,800,40,40},{1640,580,40,40},{2280,360,40,40},{1640,200,40,40},{1260,1120,40,40}};
static char texts[6][2][140]={
{"  -  . 4 - .",
  "Green panel can appear or disappear, P button. 4 is jumping."},
{"   .     TAB",
  "There are some holes in the walls. Look at map by TAB."},
{"    =   ",
  "Use = button to shoot a flower and quickly get up."},
{",    ,  6,  ,     .",
  "Climb up and use 6 panel button to shoot. If you are tight to the block, you can shoot throught it. Then free guns and get all things."},
{",  9- .    Shift: - ,  - ",
  "Climb up, set weapon 9 and shoot. Than you can press left SHIFT to make bee fly to you, right to make if fly off."},
{"    .   .",
  "The thing in the floor can stop the river. Get up by the ledder."}};
switch (a){
case HIF_LEVHAND_INIT:hif_level_info.rivers[6].xs=40;door_state=0;memset(flags,0,6);break;
case HIF_LEVHAND_LOAD:BZ2_bzread(f,&door_state,1);BZ2_bzread(f,flags,6);break;
case HIF_LEVHAND_SAVE:BZ2_bzwrite(f,&door_state,1);BZ2_bzwrite(f,flags,6);break;
case HIF_LEVHAND_PROCIDLE:if ((door_state==0)&&(hif_level_info.walls[1673]==0))door_state=1;
  if (door_state==1)if ((hif_level_info.rivers[6].xs+=4)==600)door_state=2;
  for (i=0;i<6;i++)if ((IN_RECT(rects[i]))&&(flags[i]==0)){flags[i]=1;HIF_AddHintSurface(texts[i][locale_type]);switch (i){
    case 0:HIF_SetPanel(3);break;case 3:HIF_SetPanel(5);break;};};break;
};
}
