#include "images.h"
#include "hif_main.h"
#include <math.h>
#include "log.h"
#include <stdlib.h>
#define HIF_REFRESH_DOORIMAGE  7
#define HIF_BONUS_PHASES 10
float hif_fps=0;
float hif_lasttime2;
const char hif_mapC[6][3]={{0,0,0},{255,255,255},{255,0,0},{0,255,0},{0,0,255},{255,192,88}};
char hif_fpsstr[]="000 . 0";
void hif_updatepanel(void)
{
SDL_Rect r1,r2;
char i,text[]="0000";
SDL_FillRect(hif_panel,NULL,C_BLACK(hif_panel));
for (i=0;i<3;i++){ASSIGNRECT(r1,80*i,2,5,5);ASSIGNRECT(r2,5*i,0,5,5);SDL_BlitSurface(images[_IMG_hif_things],&r2,hif_panel,&r1);};
for (i=0;i<3;i++){
  if (hif_player_info.keys[i]<10){text[0]='0'+hif_player_info.keys[i];text[1]='\0';}else
    {if (hif_player_info.keys[i]<100){text[0]='0'+hif_player_info.keys[i]/10;text[1]='0'+hif_player_info.keys[i]%10;text[2]='\0';}else
      text[0]='9';text[1]='9';text[2]='\0';};
font->OutText(80*i+8,0,C_WHITE(hif_panel),&(text[0]),hif_panel);
};
text[3]='0'+hif_player_info.health%10;
text[2]=(hif_player_info.health>=10)?('0'+(hif_player_info.health/10)%10):' ';
text[1]=(hif_player_info.health>=100)?('0'+(hif_player_info.health/100)%10):' ';
text[0]=(hif_player_info.health>=1000)?('0'+(hif_player_info.health/1000)%10):' ';
if(hif_player_info.health>9999){text[0]=text[1]=text[2]=text[3]='@';};
font->OutText(250,0,C_WHITE(hif_panel),&(text[0]),hif_panel);
if (hif_player_info.weapon!=0){ASSIGNRECT(r1,5*(hif_player_info.weapon+HIF_THING_FIRSTSHELL-1),0,5,5);ASSIGNRECT(r2,300,0,5,5);
    SDL_BlitSurface(images[_IMG_hif_things],&r1,hif_panel,&r2);
text[3]='0'+hif_player_info.weapons[hif_player_info.weapon]%10;
text[2]=(hif_player_info.weapons[hif_player_info.weapon]>=10)?('0'+(hif_player_info.weapons[hif_player_info.weapon]/10)%10):' ';
text[1]=(hif_player_info.weapons[hif_player_info.weapon]>=100)?('0'+(hif_player_info.weapons[hif_player_info.weapon]/100)%10):' ';
text[0]=(hif_player_info.weapons[hif_player_info.weapon]>=1000)?('0'+(hif_player_info.weapons[hif_player_info.weapon]/1000)%10):' ';
if(hif_player_info.weapons[hif_player_info.weapon]>9999){text[0]=text[1]=text[2]=text[3]='@';};
font->OutText(310,0,C_WHITE(hif_panel),&(text[0]),hif_panel);
};
ASSIGNRECT(r1,240,2,5,5);ASSIGNRECT(r2,0,5,5,5);
SDL_BlitSurface(images[_IMG_hif_things],&r2,hif_panel,&r1);
if (hif_player_info.num_prebeer!=0){
ASSIGNRECT(r1,360,0,5,5);ASSIGNRECT(r2,80,0,5,5);SDL_BlitSurface(images[_IMG_hif_things],&r2,hif_panel,&r1);
text[3]='0'+hif_player_info.num_prebeer%10;
text[2]=(hif_player_info.num_prebeer>=10)?('0'+(hif_player_info.num_prebeer/10)%10):' ';
text[1]=(hif_player_info.num_prebeer>=100)?('0'+(hif_player_info.num_prebeer/100)%10):' ';
text[0]=(hif_player_info.num_prebeer>=1000)?('0'+(hif_player_info.num_prebeer/1000)%10):' ';
if(hif_player_info.num_prebeer>9999){text[0]=text[1]=text[2]=text[3]='@';};
font->OutText(370,0,C_WHITE(hif_panel),&(text[0]),hif_panel);
};
}
void hif_refresh(void)
{
#define HIF_NUM_ANIMATED 17
#define HIF_X_IMAGES 6
#define HIF_REFRESH_SHOWIMAGE if (no!=0){\
  if (no>=1000){\
    ASSIGNRECT(r1,40*((hif_ticks/2)%hif_animated[no-1000]),40*(no-1000),40,40);\
    HIF_BlitStdSurface(_IMG_hif_hed_images_ani,&r1,&r2);\
  } else {\
    ASSIGNRECT(r1,40*((no-1)%HIF_X_IMAGES),40*((no-1)/HIF_X_IMAGES),40,40);\
    HIF_BlitStdSurface(_IMG_hif_hed_images_2,&r1,&r2);\
  };\
};
static const Sint16 hif_score_digits[11]={0,32,50,80,108,138,166,195,224,254,282};
static const char hif_animated[HIF_NUM_ANIMATED]={8,8,8,8,5,5,5,8,8,8,6,6,7,4,4,8,8};
int x0,y0,x,y,i;
Uint16 no;
char no2;
Uint32 time;
SDL_Rect r1,r2;
log_block[1]=LOG_HIF_REFRESH;log_block[2]=0;
HIF_FillRect(screen,NULL,C_BLACK(screen));
x0=hif_player_info.x-hif_level_info.delta_x0-320;y0=hif_player_info.y-hif_level_info.delta_y0-240;
if (abs(hif_level_info.delta_x0)>40){hif_level_info.delta_x0-=30*SGN(hif_level_info.delta_x0);}else{hif_level_info.delta_x0=0;};
if (abs(hif_level_info.delta_y0)>40){hif_level_info.delta_y0-=30*SGN(hif_level_info.delta_y0);}else{hif_level_info.delta_y0=0;};
if (abs(hif_level_info.delta_x0)>abs(hif_level_info.delta_y0))
  {hif_level_info.delta_x0=(int)(hif_level_info.delta_x0/1.3);}else{hif_level_info.delta_y0=(int)(hif_level_info.delta_y0/1.3);};
if (x0<0)x0=0;if (y0<0)y0=0;
if (x0>=hif_level_info.xsize*40-640)x0=hif_level_info.xsize*40-641;if (y0>=hif_level_info.ysize*40-480)y0=hif_level_info.ysize*40-481;
i=(hif_player_info.t_drank+HIF_DRANK_QUATER-1)/HIF_DRANK_QUATER;
if (i!=0){x0+=rand()%(2*i)-i;y0+=rand()%(2*i)-i;};
if (x0<0)x0=0;if (y0<0)y0=0;
if (x0>=hif_level_info.xsize*40-640)x0=hif_level_info.xsize*40-641;if (y0>=hif_level_info.ysize*40-480)y0=hif_level_info.ysize*40-481;
//show bg
log_block[2]=1;
for (x=(x0/40);x<(x0/40)+17;x++)for (y=(y0/40);y<(y0/40)+13;y++)
      {ASSIGNRECT(r2,x*40-x0,y*40-y0,40,40);no=hif_level_info.bg[hif_level_info.xsize*y+x];HIF_REFRESH_SHOWIMAGE;};
//show vents
log_block[2]=2;
for (x=0;x<hif_level_info.numvents;x++)hif_level_info.vents[x].refresh(x0,y0,hif_fastwalks[0][x]);
//show rivers
log_block[2]=3;
for (x=0;x<hif_level_info.numrivers;x++)hif_level_info.rivers[x].refresh(x0,y0,hif_fastwalks[1][x]);
//show hendehoh
log_block[2]=4;
ASSIGNRECT(r1,hif_player_info.x-x0-19,hif_player_info.y-y0-19,40,40);
switch(hif_player_info.state){
  case HIF_STATE_WALKING:switch (hif_player_info.size){
    case 0:case 1:case 2:ASSIGNRECT(r2,(1-hif_player_info.direction)*40,40*hif_player_info.size,40,40);
    HIF_BlitStdSurface(_IMG_hif_hedgehog,&r2,&r1);
    ASSIGNRECT(r2,(1-hif_player_info.direction)*11+80,8*hif_player_info.phase,11,8);
    ASSIGNRECT(r1,hif_player_info.x-x0-4-hif_player_info.direction,hif_player_info.y-y0+13,11,8);
    HIF_BlitStdSurface(_IMG_hif_hedgehog,&r2,&r1);break;
    case 3:ASSIGNRECT(r2,40*(hif_player_info.phase%2),40*(3+hif_player_info.phase/2),40,40);
    HIF_BlitStdSurface(_IMG_hif_hedgehog,&r2,&r1);break;
  };break;
  case HIF_STATE_PRESSING:ASSIGNRECT(r1,0,200,40,40);
    ASSIGNRECT(r2,hif_player_info.x-x0-19,hif_player_info.y+hif_sizes[hif_player_info.size][3]-35-y0,40,40);
    HIF_BlitStdSurface(_IMG_hif_hedgehog,&r1,&r2);break;
};
//show walls
log_block[2]=5;
for (x=(x0/40);x<(x0/40)+17;x++)
for (y=(y0/40);y<(y0/40)+13;y++)
{
ASSIGNRECT(r2,x*40-x0,y*40-y0,40,40);no=0;no2=-1;
switch (hif_level_info.walls[hif_level_info.xsize*y+x]){
case 3:case 5:case 7:no=HIF_REFRESH_DOORIMAGE+(hif_level_info.walls[hif_level_info.xsize*y+x]-3)/2;
    no2=(hif_level_info.walls[hif_level_info.xsize*y+x]+1)/2;break;
case 1:no2=1;break;
case 8:no2=5;break;
default:no2=0;
};
HIF_REFRESH_SHOWIMAGE;
if ((no2!=-1)&&(no2!=hif_level_info.map[hif_level_info.xsize*y+x])){
  SDL_Rect r1={2*x,2*y,2,2};HIF_FillRect(hif_map,&r1,SDL_MapRGB(hif_map->format,hif_mapC[no2][0],hif_mapC[no2][1],hif_mapC[no2][2]));
  hif_level_info.map[hif_level_info.xsize*y+x]=no2;
};
};
//show things
log_block[2]=6;
for (i=0;i<hif_level_info.numthings;i++)hif_level_info.things[i].refresh(x0,y0);
for (i=0;i<hif_level_info.numthings_rest;i++)hif_level_info.things_rest[i].refresh(x0,y0);
//show enemies
log_block[2]=7;
for (i=0;i<hif_level_info.numenemies;i++)if (hif_level_info.enemies[i]->health>0)hif_level_info.enemies[i]->refresh(x0,y0);
//show fg
log_block[2]=8;
for (x=(x0/40);x<(x0/40)+17;x++)for (y=(y0/40);y<(y0/40)+13;y++)
    {ASSIGNRECT(r2,x*40-x0,y*40-y0,40,40);no=hif_level_info.fg[hif_level_info.xsize*y+x];HIF_REFRESH_SHOWIMAGE;};
//show lines
log_block[2]=9;
for (x=0;x<hif_level_info.numlines;x++)hif_level_info.lines[x].refresh(x0,y0);
//show drops
log_block[2]=10;
for (x=0;x<hif_level_info.numdrops;x++)hif_level_info.drops[x].refresh(x0,y0);
//show events
log_block[2]=11;
for (x=0;x<hif_numevents;x++)switch(hif_events[x].type){
case HIF_EVENT_TEXT:
ASSIGNRECT(r1,hif_events[x].x-x0+(HIF_TEXT_NPHASES-hif_events[x].phase),
    hif_events[x].y-y0-2*(HIF_TEXT_NPHASES-hif_events[x].phase),hif_texts[hif_events[x].image1]->w,8);
ASSIGNRECT(r2,0,8*(HIF_TEXT_NPHASES-hif_events[x].phase),hif_texts[hif_events[x].image1]->w,8);
HIF_BlitSurface(hif_texts[hif_events[x].image1],&r2,screen,&r1);break;
case HIF_EVENT_TWOIMAGES:case HIF_EVENT_TWOIMAGES+1:case HIF_EVENT_TWOIMAGES+2:
ASSIGNRECT(r1,hif_events[x].x*40-x0,hif_events[x].y*40-y0,40,40);
ASSIGNRECT(r2,(hif_animated[hif_events[x].image1]-hif_events[x].phase)*40,hif_events[x].image1*40,40,40);
HIF_BlitStdSurface(_IMG_hif_hed_images_ani,&r2,&r1);break;
case HIF_EVENT_ENEMY_DYING:ASSIGNRECT(r1,hif_events[x].x-x0,hif_events[x].y-y0,40,40);
ASSIGNRECT(r2,40*(HIF_ENEMY_DEADPHASES(hif_events[x].image1)-hif_events[x].phase),40*hif_events[x].image1,40,40);
HIF_BlitStdSurface(_IMG_hif_enemies_dying,&r2,&r1);break;
};
//show blocks
log_block[2]=12;
for (i=0;i<hif_level_info.numblocks;i++)hif_level_info.blocks[i].refresh(x0,y0);
//show bee
log_block[2]=13;
if (hif_level_info.bee.enabled)hif_level_info.bee.refresh(x0,y0);
//show fireballs
log_block[2]=14;
for (i=0;i<hif_level_info.numfireballs;i++)hif_level_info.fireballs[i].refresh(x0,y0);
//show current weapon
log_block[2]=15;
ASSIGNRECT(r1,609,439,22,22);
  HIF_FillRect(screen,&r1,SDL_MapRGB(screen->format,150+(hif_ticks/2)%86,150+(hif_ticks/3)%86,150+(hif_ticks/4)%86));
ASSIGNRECT(r1,610,440,20,20);ASSIGNRECT(r2,(hif_player_info.size<2)?(20*hif_player_info.weapon):(0),0,20,20);
HIF_BlitStdSurface(_IMG_hif_hed_weapons,&r2,&r1);
//show air
log_block[2]=16;
for (i=0;i<hif_level_info.numair;i++)hif_level_info.air[i].refresh(x0,y0);
//refresh using level handler
log_block[2]=17;
hif_handler(HIF_LEVHAND_REFRIDLE,0,NULL,x0,y0);
//show panel
log_block[2]=18;
ASSIGNRECT(r1,0,480-hif_panel->h,640,hif_panel->h);
HIF_BlitSurface(hif_panel,NULL,screen,&r1);
//wait to make needed fps
log_block[2]=19;
if (fps!=100){hif_lasttime2+=1000.0/fps;while(SDL_GetTicks()<hif_lasttime2);};
//show fps
log_block[2]=20;
time=SDL_GetTicks();
if (time!=hif_last_time)hif_fps=0.9*hif_fps+0.1*(1000.0/(time-hif_last_time));
hif_last_time=time;
if (show_fps==1){
hif_fpsstr[0]=((hif_fps>=100)?((int)floor(hif_fps)/100+'0'):(' '));
hif_fpsstr[1]=((hif_fps>=10)?(((int)floor(hif_fps)/10)%10+'0'):(' '));
hif_fpsstr[2]=(int)floor(hif_fps)%10+'0';
hif_fpsstr[6]=(int)floor(10*(hif_fps-floor(hif_fps)))+'0';
HIF_ShowFPS();
};
//show apanel
log_block[2]=21;
if (hif_player_info.apanel_state!=HIF_PANEL_NONE){switch(hif_player_info.apanel_state){
case HIF_PANEL_HERE:x=y=0;break;
case HIF_PANEL_HIDING:x=(int)(640*(1-hif_player_info.apanel_pos));y=(int)(480*(1-hif_player_info.apanel_pos));break;
case HIF_PANEL_SHOWING:x=(int)(-100*hif_player_info.apanel_pos);y=(int)(-480*hif_player_info.apanel_pos);break;
case HIF_PANEL_NONE:break;
};
for (i=0;i<6;i++){
ASSIGNRECT(r1,x,y+80*i,80,80);ASSIGNRECT(r2,0,i*80,80,80);
switch (hif_player_info.apanel_opts[i]){
case 0:r2.x=80;break;case 1:break;default:
r2.x=80;r2.w=80*hif_player_info.apanel_opts[i]/hif_apanel_times[i];HIF_BlitStdSurface(_IMG_hif_apanel,&r2,&r1);
ASSIGNRECT(r1,x+80*hif_player_info.apanel_opts[i]/hif_apanel_times[i]+1,y+80*i,80,80);
ASSIGNRECT(r2,r1.x-x,i*80,80-r1.x+x,80);
};
HIF_BlitStdSurface(_IMG_hif_apanel,&r2,&r1);
};
};
//show scores
log_block[2]=22;
x=640;i=hif_player_info.scores;
while (i!=0){
  y=x;x-=hif_score_digits[1+i%10]-hif_score_digits[i%10];
  ASSIGNRECT(r1,x,0,y-x,images[_IMG_hif_scores]->h);ASSIGNRECT(r2,hif_score_digits[i%10],0,y-x,images[_IMG_hif_scores]->h);
  HIF_BlitStdSurface(_IMG_hif_scores,&r2,&r1);i/=10;
};
//show hints
HIF_ShowAllHints();
//show air line
log_block[2]=24;
ASSIGNRECT(r1,420,474,hif_player_info.air/10,5);HIF_FillRect(screen,&r1,C_GRAY(screen,200));
ASSIGNRECT(r1,420,472,hif_player_info.air/10,1);HIF_FillRect(screen,&r1,C_GRAY(screen,140));
ASSIGNRECT(r1,420,479,hif_player_info.air/10,1);HIF_FillRect(screen,&r1,C_GRAY(screen,140));
ASSIGNRECT(r1,420,473,hif_player_info.air/10,1);HIF_FillRect(screen,&r1,C_GRAY(screen,180));
ASSIGNRECT(r1,420,478,hif_player_info.air/10,1);HIF_FillRect(screen,&r1,C_GRAY(screen,180));
//show scored things
log_block[2]=25;
for (i=0;i<hif_level_info.numscth;i++)hif_level_info.scth[i].refresh(x0,y0);
//show map
log_block[2]=26;
if (hif_toshowmap==1){
SDL_Rect r1={(640-hif_map->w)/2,(480-hif_map->h)/2,hif_map->w,hif_map->h},r2={r1.x+hif_player_info.x/20,r1.y+hif_player_info.y/20,1,1};
HIF_BlitSurface(hif_map,NULL,screen,&r1);HIF_FillRect(screen,&r2,C_WHITE(screen));
};
}
