#include "images.h"
#include <bzlib.h>
#include <stdlib.h>
#include "log.h"
SDL_Surface *images[NUM_IMAGES];
Uint8 fps=35,show_fps=0;
void IMAGES_Init(void)
{
BZFILE *f;
int a,size,n,n2=1;
void *ptr;
SDL_RWops *ops;
SDL_Surface *s;
SDL_VideoInfo *vid_info;
if (screen->flags&SDL_DOUBLEBUF)n2++;
for (n=0;n<n2;n++){
  SDL_Rect r1={100,100,NUM_IMAGES+2,10},r2={100,110,13,10};
  SDL_FillRect(screen,NULL,C_BLACK(screen));
  SDL_FillRect(screen,&r1,C_GRAY(screen,120));SDL_FillRect(screen,&r2,C_GRAY(screen,120));
  SDL_Flip(screen);
};
if ((f=BZ2_bzopen("images.bz2","r"))==NULL){fprintf(LOG,"Error opening images.bz2, %s\n",BZ2_bzerror(f,&a));SDL_Quit();exit(1);};
for (a=0;a<NUM_IMAGES;a++){
if ((BZ2_bzread(f,&size,4))!=4){fprintf(LOG,"images.bz2 is too small\n");SDL_Quit();exit(1);};
ptr=malloc(size);if ((BZ2_bzread(f,ptr,size))!=size){fprintf(LOG,"images.bz2 is too small\n");SDL_Quit();exit(1);};
ops=SDL_RWFromMem(ptr,size);images[a]=SDL_LoadBMP_RW(ops,0);
SDL_FreeRW(ops);free(ptr);
for (n=0;n<n2;n++){SDL_Rect r1={100+a,100,1,10};SDL_FillRect(screen,&r1,C_WHITE(screen));SDL_Flip(screen);};
};
BZ2_bzclose(f);
vid_info=(SDL_VideoInfo*)(SDL_GetVideoInfo());
if (vid_info->hw_available)for (a=0;a<NUM_IMAGES;a++){
  s=SDL_CreateRGBSurface(SDL_HWSURFACE,images[a]->w,images[a]->h,screen->format->BitsPerPixel,SURFACE_COLOURS);
  SDL_BlitSurface(images[a],NULL,s,NULL);SDL_FreeSurface(images[a]);images[a]=s;};
for (a=0;a<NUM_IMAGES;a++)if (a!=_IMG_aafont)SDL_SetColorKey(images[a],SDL_RLEACCEL|SDL_SRCCOLORKEY,C_BLACK(images[a]));
for (n=0;n<n2;n++){SDL_Rect r1={100+NUM_IMAGES,100,1,10};SDL_FillRect(screen,&r1,C_WHITE(screen));SDL_Flip(screen);};
fprintf(LOG,"Images were loaded.\n");
}
void IMAGES_Done(void)
{
int a;
for(a=0;a<NUM_IMAGES;a++){SDL_FreeSurface(images[a]);};
fprintf(LOG,"Images were unloaded.\n");
}
void IMAGES_ChangeVideoMode(int width,int height,int bpp,Uint32 flags)
{
int i;
#define YESNO(t) (((flags&t)==0)?("no"):(""))
fprintf(LOG,"Changing video mode to %i x %i, %i bpp, %s GL, %s doublebuf, %s hardware, %s fullscreen\n",width,height,bpp,YESNO(SDL_OPENGL),
  YESNO(SDL_DOUBLEBUF),YESNO(SDL_HWSURFACE),YESNO(SDL_FULLSCREEN));
for (i=0;i<NUM_IMAGES;i++){SDL_FreeSurface(images[i]);};SDL_FreeSurface(screen);
if ((screen=SDL_SetVideoMode(width,height,bpp,flags))==NULL){fprintf(LOG,"Could not set video mode: %s.\n",SDL_GetError());return;};
IMAGES_Init();
}
