#include "locale.h"
#include "log.h"
#include <stdlib.h>
#include <string.h>
Uint8 locale_type;
char locale_name[LOCALENAMESIZE];
char *_locale_[LOCALESIZE];
void LOCALE_Init(void)
{
const char LOCALE_RU[]=
" \0"
" \0"
"\0"
" \0"
"\0"
"\0"
" \0"
"\0"
"\0"
"    \0"
"  \0"
" \0"
" \0"
"  \0"
" ,  .    -\0"
" \0"
"    \0"
"    \0"
" \0"
",   \0"
"\0"
"  \0"
"\0"
"\0"
"  \0"
"\0"
"\0"
"  \0"
"    !!!\0"
"   !\0"
"!\0"
",  !\0"
" :   .\0";
const char LOCALE_EN[]=
"Unused slot\0"
"Select music\0"
"Continue\0"
"New game\0"
"Save\0"
"Load\0"
"Help\0"
"Options\0"
"Exit\0"
"Do not save or load\0"
"Frames per second\0"
"Music volume\0"
"Sound volume\0"
"Quit\0"
"Everything is awful. Click somewhere after reading\0"
"Get a key\0"
"Got some food\0"
"Big drop!\0"
"Be more accurate!!\0"
"Normal door - strange...\0"
"Mushroom\0"
"Small stones\0"
"Big stones\0"
"Sleep-maker\0"
"Big sleep-maker\0"
"Trap\0"
"Mine\0"
"Beer for bee\0"
"Get the bee!!!\0"
"Bee ran out ouf beer!\0"
"Get up!\0"
"Coin!\0"
"Comething to make beer.\0";
const char locale_names[LOCALE_MAX+1][LOCALENAMESIZE]={"russian","english"};
const int locale_sizes[LOCALE_MAX+1]={sizeof(LOCALE_RU),sizeof(LOCALE_EN)};
char *locales[LOCALE_MAX+1]={(char *)LOCALE_RU,(char *)LOCALE_EN};
int i;
char *c;
for (i=0;i<LOCALE_MAX+1;i++)if (strcmp(locale_names[i],locale_name)==0)break;
if (i==LOCALE_MAX+1)
  {fprintf(LOG,"Warning (locale.cpp): could not find locale \"%s\", falling to \"English\"\n",locale_name);locale_type=LOCALE_ENGLISH;}else{locale_type=i;};
fprintf(LOG,"Loading locale \"%s\" ...",locale_names[locale_type]);
c=(char *)malloc(locale_sizes[locale_type]);memcpy(c,locales[locale_type],locale_sizes[locale_type]);
for (i=0;i<LOCALESIZE;i++){_locale_[i]=c;while(*c!='\0')c++;c++;};
fprintf(LOG,"OK.\n");
}

