#ifndef _LOCALE_H_
#define _LOCALE_H_
#include <SDL/SDL_types.h>
extern Uint8 locale_type;
#define LOCALE_RUSSIAN 0
#define LOCALE_ENGLISH 1
#define LOCALE_MAX 1
#define LOCALE_UKRAINIAN 2 //not yet implemented
#define LOCALENAMESIZE 20
extern char locale_name[LOCALENAMESIZE];
void LOCALE_Init(void);
#define LOCALESIZE 33
extern char *_locale_[LOCALESIZE];
#define LOCALE_UNUSED_SLOT (_locale_[0])
#define LOCALE_MENU_SETMUSIC (_locale_[1])
#define LOCALE_MENU_CONTINUE (_locale_[2])
#define LOCALE_MENU_NEWGAME (_locale_[3])
#define LOCALE_MENU_SAVEGAME (_locale_[4])
#define LOCALE_MENU_LOADGAME (_locale_[5])
#define LOCALE_MENU_HELP (_locale_[6])
#define LOCALE_MENU_OPTIONS (_locale_[7])
#define LOCALE_MENU_EXIT (_locale_[8])
#define LOCALE_MENU_LOADCANCEL (_locale_[9])
#define LOCALE_MENU_FPS (_locale_[10])
#define LOCALE_MENU_MUS_VOL (_locale_[11])
#define LOCALE_MENU_SND_VOL (_locale_[12])
#define LOCALE_MENU_OPTSQUIT (_locale_[13])
#define LOCALE_ALL_IS_BAD (_locale_[14])
#define LOCALE_HIF_TOOK_KEY (_locale_[15])
#define _LOCALE_HIF_TOOK_KEY 15
#define LOCALE_HIF_TOOK_FOOD (_locale_[16])
#define _LOCALE_HIF_TOOK_FOOD 16
#define LOCALE_HIF_DAMAGED_BY_DROP (_locale_[17])
#define _LOCALE_HIF_DAMAGED_BY_DROP 17
#define LOCALE_HIF_HURTED (_locale_[18])
#define _LOCALE_HIF_HURTED 18
#define LOCALE_HIF_OPENDOOR (_locale_[19])
#define _LOCALE_HIF_OPENDOOR 19
#define LOCALE_HIF_FIRSTSHELL 20
#define HIF_FIRST_LOCALE 15
#define _LOCALE_HIF_BEE_NOQUIT 28
#define _LOCALE_HIF_GETUP 30
#define _LOCALE_HIF_GETS_COIN 31
#define HIF_LAST_LOCALE 32
#define LOCALE_HIF_BEEDIED_ 29
#define _LOCALE_HIF_TOOK_PREBEER 32
#endif
