#include "log.h"
#include <stdlib.h>
#include <time.h>
#ifndef _WIN32
#include <pwd.h>
#include <sys/types.h>
#include <unistd.h>
#endif
#include "sg.h"
#include <signal.h>
#include <sys/stat.h>
char log_block[3];
static char log_done=0;
struct passwd *password;
FILE *LOG;
void LOG_sighandler(int a)
{
char init_phases[6][20]={"SDL_Init()","parser","SDL_SetVideoMode","images","sound","finished"};
static char faulted=0;
if (faulted==1){exit(1);};
faulted=1;
if (log_done==1){printf("Segmentation fault after LOG_Done. Strange bug.\n");exit(1);};
fprintf(LOG,"Segmentation fault in ");
switch (log_block[0]){
case LOG_INIT:fprintf(LOG,"init->%s\n",init_phases[log_block[1]]);break;
case LOG_HIF:fprintf(LOG,"hif->");switch(log_block[1]){
case LOG_HIF_INIT:fprintf(LOG,"init %i\n",log_block[2]);break;
case LOG_HIF_PROCEED:fprintf(LOG,"proc %i\n",log_block[2]);break;
case LOG_HIF_REFRESH:fprintf(LOG,"refr %i\n",log_block[2]);break;
case LOG_HIF_DONE:fprintf(LOG,"done\n");break;
default:fprintf(LOG,"???\n");break;
};break;
case LOG_HW:fprintf(LOG,"hw\n");break;
case LOG_LL:fprintf(LOG,"ll\n");break;
case LOG_DONE:fprintf(LOG,"done\n");break;
default:fprintf(LOG,"unknown block\n");
};exit(1);
}
void LOG_Init(void)
{
time_t t=time(0);
#ifndef _WIN32
char LOG_NAME[70];
if ((password=getpwuid(getuid()))!=NULL){
  sprintf(LOG_NAME,"%s/.hendehoh",password->pw_dir);mkdir(LOG_NAME,0777);
  sprintf(LOG_NAME,"%s/.hendehoh/hendehoh.log",password->pw_dir);
  homedir=password->pw_dir;}else
  {fprintf(LOG,"Error getting info for user, UID %i\n",getuid());};
#else
#define LOG_NAME "hendehoh.log"
#endif
if ((LOG=fopen(LOG_NAME,"w"))==NULL){
 printf("Error opening log file for writing, writing to stdout\n");LOG=stdout;
 };
setbuf(LOG,NULL);
fprintf(LOG,"Log started at %s",ctime(&t));
signal(SIGSEGV,LOG_sighandler);
}
void LOG_Done(void)
{
time_t t=time(0);
fprintf(LOG,"Finished logging at %s",ctime(&t));
if (LOG!=stdout)fclose(LOG);
log_done=1;
//signal(SIGSEGV,SIG_DFL);
}
