#ifndef _SOUND_H_
#define _SOUND_H_
#include <SDL/SDL_types.h>
#include <SDL/SDL_mixer.h>
#define SND_MUSICNAMESIZE 80
extern char SND_musicname[SND_MUSICNAMESIZE];
void SND_Init(void);
void SND_SetMusic(int no);
void SND_StopMusic(void);
void SND_PlayWave(int no,Sint8 priority);
#define _SND_bee_breathing 1
#define _SND_bee_st_falling 2
#define _SND_bee_thinking 3
extern Uint8 SND_WAV_volume,SND_MUS_volume,SND_MUS_chan;
extern char SND_enabled;
void SND_SetMVolume(void);
void SND_SetWVolume(void);
void SND_Done(void);
void SND_AddMusic(void);
void SND_LoadExtraMusic(void);
void SND_PlayExtraMusic(void);
void SND_SetExtraMusic(int no);
#define NUM_EXTRA_MUSICS 20
typedef struct {char name[SND_MUSICNAMESIZE];Mix_Music *music;} SND_EXTRAMUSIC;
extern SND_EXTRAMUSIC SND_extramusic[NUM_EXTRA_MUSICS];
extern char num_extramusics;
#endif
