#ifndef _IMAGES_H_
#define _IMAGES_H_
#include <SDL/SDL.h>
#include "EL.h"
void IMAGES_Init(void);//-1 = bad, 0=OK
void IMAGES_Done(void);
void IMAGES_ChangeVideoMode(int width,int height,int bpp,Uint32 flags);
enum {
_IMG_font,
_IMG_hif_hed_images_2,
_IMG_hif_hed_images_ani,
_IMG_hif_hedgehog,
_IMG_hif_things,
_IMG_hif_bee_left,
_IMG_hif_bee_right,
_IMG_arrow_r,
_IMG_menu_fon,
_IMG_hif_hed_weapons,
_IMG_hif_fireball,
_IMG_aafont,
_IMG_hif_enemies_dying,
_IMG_hif_apanel,
_IMG_hif_scores,
NUM_IMAGES
};
extern SDL_Surface *images[NUM_IMAGES];
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
#define SURFACE_COLOURS 0xff000000,0x00ff0000,0x0000ff00,0
#else
#define SURFACE_COLOURS 0x000000ff,0x0000ff00,0x00ff0000,0
#endif
extern SDL_Surface *screen;
#define C_BLACK(s) SDL_MapRGB(s->format,0,0,0)
#define C_WHITE(s) SDL_MapRGB(s->format,255,255,255)
#define C_GRAY(s,c) SDL_MapRGB(s->format,c,c,c)
#define ASSIGNRECT(r,a,b,c,d) r.x=a;r.y=b;r.w=c;r.h=d
#define PI 3.14150265348
extern Uint8 fps,show_fps;
extern Uint32 screen_flags;
extern EL_Font *font;
void SMFONT_Init(void);
#endif
