#include <SDL/SDL.h>
#include <SDL/SDL_keysym.h>
#include "images.h"
#include "locale.h"
#include <stdlib.h>
#include "log.h"
void misc_waitforkey(void)
{
SDL_Event event;
char i=0;
while (i==0)
{
if (SDL_PollEvent(&event)){
switch (event.type){
case SDL_QUIT:SDL_Quit();break;
case SDL_MOUSEBUTTONDOWN:case SDL_KEYDOWN: i=1;
};
};
};
};
void misc_getkeyboard(void)
{
Uint8 *ptr;
int i;
SDL_Event event;
ptr=SDL_GetKeyState(NULL);
for (i=0;i<SDLK_LAST;i++){
if ((ptr[i])&&(i!=SDLK_ESCAPE)){
event.type=SDL_KEYDOWN;
event.key.type=SDL_KEYDOWN;
event.key.state=SDL_PRESSED;
event.key.keysym.sym=(SDLKey)i;
SDL_PushEvent(&event);
};
};
};
void misc_fail(char *c)
{
SDL_Rect r1;
int i;
SDL_Event event;
char allready=0;
fprintf(LOG,"misc_fail: %s\n",c);
ASSIGNRECT(r1,80,160,460,160);SDL_FillRect(screen,&r1,C_BLACK(screen));
for (i=0;i<40;i++){
ASSIGNRECT(r1,80+i,160+i,1,160-i-i);
SDL_FillRect(screen,&r1,SDL_MapRGB(screen->format,(char)((250-abs(20-i))/1.5),(char)(250-5*abs(20-i)),(char)(250-9*abs(20-i))));
ASSIGNRECT(r1,80+i,160+i,460-i-i,1);
SDL_FillRect(screen,&r1,SDL_MapRGB(screen->format,(char)(250-2*abs(20-i)),(char)((250-6*abs(20-i))/1.5),(char)(250-10*abs(20-i))));
ASSIGNRECT(r1,540-i,160+i,1,162-i-i);
SDL_FillRect(screen,&r1,SDL_MapRGB(screen->format,(char)(250-3*abs(20-i)),(char)((250-7*abs(20-i))/1.5),(char)(250-11*abs(20-i))));
ASSIGNRECT(r1,80+i,320-i,460-i-i,1);
SDL_FillRect(screen,&r1,SDL_MapRGB(screen->format,(char)((250-4*abs(20-i))/1.5),(char)(250-8*abs(20-i)),(char)(250-12*abs(20-i))));
};
font->OutText(130,220,SDL_MapRGB(screen->format,255,255,255),c,screen);
font->OutText(130,50,SDL_MapRGB(screen->format,255,255,255),LOCALE_ALL_IS_BAD,screen);
SDL_Flip(screen);
while (allready==0){
if (SDL_PollEvent(&event)){
switch (event.type){
case SDL_KEYDOWN:case SDL_MOUSEBUTTONDOWN:allready=1;SDL_PushEvent(&event);break;};};};
}
void misc_clearevents(void)
{
SDL_Event event;
while (SDL_PollEvent(&event));
}
